Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -86,5 +86,5 @@
  * and consume system resources.
  *
- * Functions that return int return a negative error code on error and do not
+ * Functions that return int return an error code on error and do not
  * set errno. Depending on function, success is signalled by returning either
  * EOK or a non-negative file handle.
@@ -104,11 +104,12 @@
  * 	aoff64_t pos = 42;
  * 	char buf[512];
- * 	ssize_t size = vfs_read(file, &pos, buf, sizeof(buf));
- * 	if (size < 0) {
+ *	size_t nread;
+ * 	rc = vfs_read(file, &pos, buf, sizeof(buf), &nread);
+ * 	if (rc != EOK) {
  * 		vfs_put(file);
- * 		return size;
+ * 		return rc;
  * 	}
  *
- *	// buf is now filled with data from file
+ *	// buf is now filled with nread bytes from file
  *
  *	vfs_put(file);
@@ -127,5 +128,5 @@
 static int root_fd = -1;
 
-static int get_parent_and_child(const char *path, char **child)
+static int get_parent_and_child(const char *path, int *parent, char **child)
 {
 	size_t size;
@@ -135,14 +136,18 @@
 
 	char *slash = str_rchr(apath, L'/');
-	int parent;
 	if (slash == apath) {
-		parent = vfs_root();
+		*parent = vfs_root();
+		if (*parent < 0) {
+			free(apath);
+			return EBADF;
+		}
 		*child = apath;
+		return EOK;
 	} else {
 		*slash = '\0';
-		parent = vfs_lookup(apath, WALK_DIRECTORY);
-		if (parent < 0) {
+		int rc = vfs_lookup(apath, WALK_DIRECTORY, parent);
+		if (rc != EOK) {
 			free(apath);
-			return parent;
+			return rc;
 		}
 		*slash = '/';
@@ -150,10 +155,11 @@
 		free(apath);
 		if (!*child) {
-			vfs_put(parent);
+			vfs_put(*parent);
 			return ENOMEM;
 		}
-	}
-
-	return parent;
+
+		return rc;
+	}
+
 }
 
@@ -232,10 +238,17 @@
  * @return              New file handle on success or a negative error code
  */
-int vfs_clone(int file_from, int file_to, bool high)
-{
+int vfs_clone(int file_from, int file_to, bool high, int *handle)
+{
+	assert(handle != NULL);
+
 	async_exch_t *vfs_exch = vfs_exchange_begin();
-	int rc = async_req_3_0(vfs_exch, VFS_IN_CLONE, (sysarg_t) file_from,
-	    (sysarg_t) file_to, (sysarg_t) high);
+	sysarg_t ret;
+	int rc = async_req_3_1(vfs_exch, VFS_IN_CLONE, (sysarg_t) file_from,
+	    (sysarg_t) file_to, (sysarg_t) high, &ret);
 	vfs_exchange_end(vfs_exch);
+
+	if (rc == EOK) {
+		*handle = ret;
+	}
 	return rc;
 }
@@ -276,8 +289,9 @@
 		return ENOMEM;
 	
-	int fd = vfs_lookup(abs, WALK_DIRECTORY);
-	if (fd < 0) {
+	int fd;
+	int rc = vfs_lookup(abs, WALK_DIRECTORY, &fd);
+	if (rc != EOK) {
 		free(abs);
-		return fd;
+		return rc;
 	}
 	
@@ -490,8 +504,8 @@
 {
 	int flags = (kind == KIND_DIRECTORY) ? WALK_DIRECTORY : WALK_REGULAR;
-	int file = vfs_walk(parent, child, WALK_MUST_CREATE | flags);
-
-	if (file < 0)
-		return file;
+	int file = -1;
+	int rc = vfs_walk(parent, child, WALK_MUST_CREATE | flags, &file);
+	if (rc != EOK)
+		return rc;
 
 	if (linkedfd)
@@ -520,14 +534,15 @@
 {
 	char *child;
-	int parent = get_parent_and_child(path, &child);
-	if (parent < 0)
-		return parent;
-
-	int rc = vfs_link(parent, child, kind, linkedfd);
+	int parent;
+	int rc = get_parent_and_child(path, &parent, &child);
+	if (rc != EOK)
+		return rc;
+
+	rc = vfs_link(parent, child, kind, linkedfd);
 
 	free(child);
 	vfs_put(parent);
 	return rc;
-}	
+}
 
 /** Lookup a path relative to the local root
@@ -535,9 +550,9 @@
  * @param path  Path to be looked up
  * @param flags Walk flags
- *
- * @return      File handle representing the result on success or a negative
- *              error code on error
- */
-int vfs_lookup(const char *path, int flags)
+ * @param[out] handle Pointer to variable where handle is to be written.
+ *
+ * @return      EOK on success or an error code.
+ */
+int vfs_lookup(const char *path, int flags, int *handle)
 {
 	size_t size;
@@ -545,4 +560,5 @@
 	if (!p)
 		return ENOMEM;
+
 	int root = vfs_root();
 	if (root < 0) {
@@ -550,5 +566,6 @@
 		return ENOENT;
 	}
-	int rc = vfs_walk(root, p, flags);
+
+	int rc = vfs_walk(root, p, flags, handle);
 	vfs_put(root);
 	free(p);
@@ -563,20 +580,23 @@
  * @param flags Walk flags
  * @param mode  Mode in which to open file in
+ * @param[out] handle Pointer to variable where handle is to be written.
  *
  * @return      EOK on success or a negative error code
  */
-int vfs_lookup_open(const char *path, int flags, int mode)
-{
-	int file = vfs_lookup(path, flags);
-	if (file < 0)
-		return file;
-
-	int rc = vfs_open(file, mode);
+int vfs_lookup_open(const char *path, int flags, int mode, int *handle)
+{
+	int file;
+	int rc = vfs_lookup(path, flags, &file);
+	if (rc != EOK)
+		return rc;
+
+	rc = vfs_open(file, mode);
 	if (rc != EOK) {
 		vfs_put(file);
 		return rc;
 	}
-	
-	return file;
+
+	*handle = file;
+	return EOK;
 }
 
@@ -706,11 +726,10 @@
 		}
 		
-		int mpfd = vfs_walk(root_fd, mpa, WALK_DIRECTORY);
-		if (mpfd >= 0) {
+		int mpfd;
+		rc = vfs_walk(root_fd, mpa, WALK_DIRECTORY, &mpfd);
+		if (rc == EOK) {
 			rc = vfs_mount(mpfd, fs_name, service_id, opts, flags,
 			    instance, NULL);
 			vfs_put(mpfd);
-		} else {
-			rc = mpfd;
 		}
 	}
@@ -774,8 +793,9 @@
  * @param high   If true, the received file handle will be allocated from high
  *               indices
+ * @param[out] handle  Received handle.
  *
  * @return       EOK on success or a negative error code
  */
-int vfs_receive_handle(bool high)
+int vfs_receive_handle(bool high, int *handle)
 {
 	ipc_callid_t callid;
@@ -794,7 +814,9 @@
 	async_exchange_end(vfs_exch);
 
-	if (rc != EOK)
-		return rc;
-	return ret;
+	if (rc == EOK) {
+		*handle = (int) ret;
+	}
+
+	return rc;
 }
 
@@ -808,12 +830,14 @@
  * @param buf		Buffer, @a nbytes bytes long
  * @param nbytes	Number of bytes to read
- *
- * @return              On success, non-negative number of bytes read
- * @return              On failure, a negative error code
- */
-ssize_t vfs_read(int file, aoff64_t *pos, void *buf, size_t nbyte)
+ * @param nread		Place to store number of bytes actually read
+ *
+ * @return              On success, EOK and @a *nread is filled with number
+ *			of bytes actually read.
+ * @return              On failure, an error code
+ */
+int vfs_read(int file, aoff64_t *pos, void *buf, size_t nbyte, size_t *nread)
 {
 	ssize_t cnt = 0;
-	size_t nread = 0;
+	size_t nr = 0;
 	uint8_t *bp = (uint8_t *) buf;
 	int rc;
@@ -821,14 +845,18 @@
 	do {
 		bp += cnt;
-		nread += cnt;
+		nr += cnt;
 		*pos += cnt;
-		rc = vfs_read_short(file, *pos, bp, nbyte - nread, &cnt);
-	} while (rc == EOK && cnt > 0 && (nbyte - nread - cnt) > 0);
-	
-	if (rc != EOK)
-		return rc;
-	
+		rc = vfs_read_short(file, *pos, bp, nbyte - nr, &cnt);
+	} while (rc == EOK && cnt > 0 && (nbyte - nr - cnt) > 0);
+	
+	if (rc != EOK) {
+		*nread = nr;
+		return rc;
+	}
+	
+	nr += cnt;
 	*pos += cnt;
-	return nread + cnt;
+	*nread = nr;
+	return EOK;
 }
 
@@ -969,16 +997,20 @@
 /** Return a new file handle representing the local root
  *
- * @return      A clone of the local root file handle or a negative error code
+ * @return      A clone of the local root file handle or -1
  */
 int vfs_root(void)
 {
-	fibril_mutex_lock(&root_mutex);	
-	int r;
-	if (root_fd < 0)
-		r = ENOENT;
-	else
-		r = vfs_clone(root_fd, -1, true);
+	fibril_mutex_lock(&root_mutex);
+	int fd;
+	if (root_fd < 0) {
+		fd = -1;
+	} else {
+		int rc = vfs_clone(root_fd, -1, true, &fd);
+		if (rc != EOK) {
+			fd = -1;
+		}
+	}
 	fibril_mutex_unlock(&root_mutex);
-	return r;
+	return fd;
 }
 
@@ -990,12 +1022,22 @@
  *
  * @param nroot The new local root file handle
- */
-void vfs_root_set(int nroot)
-{
+ *
+ * @return  Error code
+ */
+int vfs_root_set(int nroot)
+{
+	int new_root;
+	int rc = vfs_clone(nroot, -1, true, &new_root);
+	if (rc != EOK) {
+		return rc;
+	}
+
 	fibril_mutex_lock(&root_mutex);
 	if (root_fd >= 0)
 		vfs_put(root_fd);
-	root_fd = vfs_clone(nroot, -1, true);
+	root_fd = new_root;
 	fibril_mutex_unlock(&root_mutex);
+
+	return EOK;
 }
 
@@ -1043,9 +1085,10 @@
 int vfs_stat_path(const char *path, struct stat *stat)
 {
-	int file = vfs_lookup(path, 0);
-	if (file < 0)
-		return file;
-	
-	int rc = vfs_stat(file, stat);
+	int file;
+	int rc = vfs_lookup(path, 0, &file);
+	if (rc != EOK)
+		return rc;
+	
+	rc = vfs_stat(file, stat);
 
 	vfs_put(file);
@@ -1088,9 +1131,10 @@
 int vfs_statfs_path(const char *path, struct statfs *st)
 {
-	int file = vfs_lookup(path, 0);
-	if (file < 0)
-		return file;
-	
-	int rc = vfs_statfs(file, st);
+	int file;
+	int rc = vfs_lookup(path, 0, &file);
+	if (rc != EOK)
+		return rc;
+	
+	rc = vfs_statfs(file, st);
 
 	vfs_put(file);
@@ -1158,16 +1202,18 @@
 int vfs_unlink_path(const char *path)
 {
-	int expect = vfs_lookup(path, 0);
-	if (expect < 0)
-		return expect;
+	int expect;
+	int rc = vfs_lookup(path, 0, &expect);
+	if (rc != EOK)
+		return rc;
 
 	char *child;
-	int parent = get_parent_and_child(path, &child);
-	if (parent < 0) {
+	int parent;
+	rc = get_parent_and_child(path, &parent, &child);
+	if (rc != EOK) {
 		vfs_put(expect);
-		return parent;
-	}
-
-	int rc = vfs_unlink(parent, child, expect);
+		return rc;
+	}
+
+	rc = vfs_unlink(parent, child, expect);
 	
 	free(child);
@@ -1199,9 +1245,10 @@
 int vfs_unmount_path(const char *mpp)
 {
-	int mp = vfs_lookup(mpp, WALK_MOUNT_POINT | WALK_DIRECTORY);
-	if (mp < 0)
-		return mp;
-	
-	int rc = vfs_unmount(mp);
+	int mp;
+	int rc = vfs_lookup(mpp, WALK_MOUNT_POINT | WALK_DIRECTORY, &mp);
+	if (rc != EOK)
+		return rc;
+	
+	rc = vfs_unmount(mp);
 	vfs_put(mp);
 	return rc;
@@ -1213,9 +1260,9 @@
  * @param path          Parent-relative path to be walked
  * @param flags         Flags influencing the walk
- *
- * @retrun              File handle representing the result on success or
- *                      a negative error code on error
- */
-int vfs_walk(int parent, const char *path, int flags)
+ * @param[out] handle   File handle representing the result on success.
+ *
+ * @return              Error code.
+ */
+int vfs_walk(int parent, const char *path, int flags, int *handle)
 {
 	async_exch_t *exch = vfs_exchange_begin();
@@ -1235,5 +1282,6 @@
 		return (int) rc;
 	
-	return (int) IPC_GET_ARG1(answer);
+	*handle = (int) IPC_GET_ARG1(answer);
+	return EOK;
 }
 
@@ -1247,12 +1295,15 @@
  * @param buf           Data, @a nbytes bytes long
  * @param nbytes        Number of bytes to write
- *
- * @return		On success, non-negative number of bytes written
- * @return              On failure, a negative error code
- */
-ssize_t vfs_write(int file, aoff64_t *pos, const void *buf, size_t nbyte)
+ * @param nwritten	Place to store number of bytes written
+ *
+ * @return		On success, EOK, @a *nwr is filled with number
+ *			of bytes written
+ * @return              On failure, an error code
+ */
+int vfs_write(int file, aoff64_t *pos, const void *buf, size_t nbyte,
+    size_t *nwritten)
 {
 	ssize_t cnt = 0;
-	ssize_t nwritten = 0;
+	ssize_t nwr = 0;
 	const uint8_t *bp = (uint8_t *) buf;
 	int rc;
@@ -1260,14 +1311,18 @@
 	do {
 		bp += cnt;
-		nwritten += cnt;
+		nwr += cnt;
 		*pos += cnt;
-		rc = vfs_write_short(file, *pos, bp, nbyte - nwritten, &cnt);
-	} while (rc == EOK && ((ssize_t )nbyte - nwritten - cnt) > 0);
-
-	if (rc != EOK)
-		return rc;
-
+		rc = vfs_write_short(file, *pos, bp, nbyte - nwr, &cnt);
+	} while (rc == EOK && ((ssize_t )nbyte - nwr - cnt) > 0);
+
+	if (rc != EOK) {
+		*nwritten = nwr;
+		return rc;
+	}
+
+	nwr += cnt;
 	*pos += cnt;
-	return nbyte;
+	*nwritten = nwr;
+	return EOK;
 }
 
Index: uspace/lib/c/include/adt/circ_buf.h
===================================================================
--- uspace/lib/c/include/adt/circ_buf.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/lib/c/include/adt/circ_buf.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file Circular buffer
+ */
+
+#ifndef LIBC_CIRC_BUF_H_
+#define LIBC_CIRC_BUF_H_
+
+#include <stddef.h>
+
+/** Circular buffer */
+typedef struct {
+	/** Buffer */
+	void *buf;
+	/** Number of buffer members */
+	size_t nmemb;
+	/** Member size */
+	size_t size;
+	/** Read position */
+	size_t rp;
+	/** Write position */
+	size_t wp;
+	/** Number of used entries */
+	size_t nused;
+} circ_buf_t;
+
+extern void circ_buf_init(circ_buf_t *, void *, size_t, size_t);
+extern size_t circ_buf_nfree(circ_buf_t *);
+extern size_t circ_buf_nused(circ_buf_t *);
+extern int circ_buf_push(circ_buf_t *, const void *);
+extern int circ_buf_pop(circ_buf_t *, void *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/adt/fifo.h
===================================================================
--- uspace/lib/c/include/adt/fifo.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/adt/fifo.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -46,5 +46,5 @@
 #define LIBC_FIFO_H_
 
-#include <malloc.h>
+#include <stdlib.h>
 
 typedef unsigned long fifo_count_t;
Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/async.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -49,6 +49,7 @@
 #include <abi/ipc/event.h>
 #include <abi/ipc/interfaces.h>
-
-typedef ipc_callid_t aid_t;
+#include <abi/cap.h>
+
+typedef sysarg_t aid_t;
 typedef sysarg_t port_id_t;
 
@@ -58,16 +59,15 @@
 /** Port connection handler
  *
- * @param callid ID of incoming call or 0 if connection initiated from
- *               inside using async_create_callback_port()
- * @param call   Incoming call or 0 if connection initiated from inside
- *               using async_create_callback_port()
- * @param arg    Local argument.
- *
- */
-typedef void (*async_port_handler_t)(ipc_callid_t, ipc_call_t *, void *);
+ * @param chandle  Handle of the incoming call or CAP_NIL if connection
+ *                 initiated from inside using async_create_callback_port()
+ * @param call     Incoming call or 0 if connection initiated from inside
+ *                 using async_create_callback_port()
+ * @param arg      Local argument.
+ *
+ */
+typedef void (*async_port_handler_t)(cap_handle_t, ipc_call_t *, void *);
 
 /** Notification handler */
-typedef void (*async_notification_handler_t)(ipc_callid_t, ipc_call_t *,
-    void *);
+typedef void (*async_notification_handler_t)(ipc_call_t *, void *);
 
 /** Exchange management style
@@ -119,5 +119,5 @@
 	async_get_call_timeout(data, 0)
 
-extern ipc_callid_t async_get_call_timeout(ipc_call_t *, suseconds_t);
+extern cap_handle_t async_get_call_timeout(ipc_call_t *, suseconds_t);
 
 /*
@@ -151,4 +151,6 @@
 
 extern void async_usleep(suseconds_t);
+extern void async_sleep(unsigned int);
+
 extern void async_create_manager(void);
 extern void async_destroy_manager(void);
@@ -167,5 +169,5 @@
 
 extern int async_irq_subscribe(int, async_notification_handler_t, void *,
-    const irq_code_t *);
+    const irq_code_t *, cap_handle_t *);
 extern int async_irq_unsubscribe(int);
 
@@ -196,12 +198,12 @@
  */
 
-extern sysarg_t async_answer_0(ipc_callid_t, sysarg_t);
-extern sysarg_t async_answer_1(ipc_callid_t, sysarg_t, sysarg_t);
-extern sysarg_t async_answer_2(ipc_callid_t, sysarg_t, sysarg_t, sysarg_t);
-extern sysarg_t async_answer_3(ipc_callid_t, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t async_answer_0(cap_handle_t, sysarg_t);
+extern sysarg_t async_answer_1(cap_handle_t, sysarg_t, sysarg_t);
+extern sysarg_t async_answer_2(cap_handle_t, sysarg_t, sysarg_t, sysarg_t);
+extern sysarg_t async_answer_3(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t);
-extern sysarg_t async_answer_4(ipc_callid_t, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t async_answer_4(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
-extern sysarg_t async_answer_5(ipc_callid_t, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t async_answer_5(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
 
@@ -210,7 +212,7 @@
  */
 
-extern int async_forward_fast(ipc_callid_t, async_exch_t *, sysarg_t, sysarg_t,
+extern int async_forward_fast(cap_handle_t, async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, unsigned int);
-extern int async_forward_slow(ipc_callid_t, async_exch_t *, sysarg_t, sysarg_t,
+extern int async_forward_slow(cap_handle_t, async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t, sysarg_t, unsigned int);
 
@@ -382,10 +384,10 @@
 extern int async_share_in_start(async_exch_t *, size_t, sysarg_t,
     unsigned int *, void **);
-extern bool async_share_in_receive(ipc_callid_t *, size_t *);
-extern int async_share_in_finalize(ipc_callid_t, void *, unsigned int);
+extern bool async_share_in_receive(cap_handle_t *, size_t *);
+extern int async_share_in_finalize(cap_handle_t, void *, unsigned int);
 
 extern int async_share_out_start(async_exch_t *, void *, unsigned int);
-extern bool async_share_out_receive(ipc_callid_t *, size_t *, unsigned int *);
-extern int async_share_out_finalize(ipc_callid_t, void **);
+extern bool async_share_out_receive(cap_handle_t *, size_t *, unsigned int *);
+extern int async_share_out_finalize(cap_handle_t, void **);
 
 /*
@@ -421,7 +423,7 @@
 extern aid_t async_data_read(async_exch_t *, void *, size_t, ipc_call_t *);
 extern int async_data_read_start(async_exch_t *, void *, size_t);
-extern bool async_data_read_receive(ipc_callid_t *, size_t *);
-extern bool async_data_read_receive_call(ipc_callid_t *, ipc_call_t *, size_t *);
-extern int async_data_read_finalize(ipc_callid_t, const void *, size_t);
+extern bool async_data_read_receive(cap_handle_t *, size_t *);
+extern bool async_data_read_receive_call(cap_handle_t *, ipc_call_t *, size_t *);
+extern int async_data_read_finalize(cap_handle_t, const void *, size_t);
 
 extern int async_data_read_forward_fast(async_exch_t *, sysarg_t, sysarg_t,
@@ -460,7 +462,7 @@
 
 extern int async_data_write_start(async_exch_t *, const void *, size_t);
-extern bool async_data_write_receive(ipc_callid_t *, size_t *);
-extern bool async_data_write_receive_call(ipc_callid_t *, ipc_call_t *, size_t *);
-extern int async_data_write_finalize(ipc_callid_t, void *, size_t);
+extern bool async_data_write_receive(cap_handle_t *, size_t *);
+extern bool async_data_write_receive_call(cap_handle_t *, ipc_call_t *, size_t *);
+extern int async_data_write_finalize(cap_handle_t, void *, size_t);
 
 extern int async_data_write_accept(void **, const bool, const size_t,
@@ -476,7 +478,7 @@
 extern int async_state_change_start(async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, async_exch_t *);
-extern bool async_state_change_receive(ipc_callid_t *, sysarg_t *, sysarg_t *,
+extern bool async_state_change_receive(cap_handle_t *, sysarg_t *, sysarg_t *,
     sysarg_t *);
-extern int async_state_change_finalize(ipc_callid_t, async_exch_t *);
+extern int async_state_change_finalize(cap_handle_t, async_exch_t *);
 
 extern void *async_remote_state_acquire(async_sess_t *);
Index: uspace/lib/c/include/bd.h
===================================================================
--- uspace/lib/c/include/bd.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/bd.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Block device client interface
  */
 
Index: uspace/lib/c/include/device/hw_res.h
===================================================================
--- uspace/lib/c/include/device/hw_res.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/device/hw_res.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -123,5 +123,5 @@
 extern int hw_res_dma_channel_setup(async_sess_t *, unsigned int, uint32_t,
     uint32_t, uint8_t);
-extern int hw_res_dma_channel_remain(async_sess_t *, unsigned);
+extern int hw_res_dma_channel_remain(async_sess_t *, unsigned, size_t *);
 
 #endif
Index: uspace/lib/c/include/elf/elf_mod.h
===================================================================
--- uspace/lib/c/include/elf/elf_mod.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/elf/elf_mod.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -53,4 +53,5 @@
 #define EE_LOADER		5	/* The image is actually a program loader. */
 #define EE_IRRECOVERABLE	6
+#define EE_IO			7	/* Could not read file. */
 
 typedef enum {
Index: uspace/lib/c/include/errno.h
===================================================================
--- uspace/lib/c/include/errno.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/errno.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,35 +40,5 @@
 #define errno  (*(__errno()))
 
-extern int *__errno(void) __attribute__((const));
-
-#define EMFILE        (-18)
-#define ENAMETOOLONG  (-256)
-#define EISDIR        (-257)
-#define ENOTDIR       (-258)
-#define ENOSPC        (-259)
-#define ENOTEMPTY     (-261)
-#define EBADF         (-262)
-#define EDOM          (-263)
-#define ERANGE        (-264)
-#define EXDEV         (-265)
-#define EIO           (-266)
-#define EMLINK        (-267)
-#define ENXIO         (-268)
-#define ENOFS         (-269)
-
-/** Bad checksum. */
-#define EBADCHECKSUM  (-300)
-
-/** USB: stalled operation. */
-#define ESTALL (-301)
-
-/** Empty resource (no data). */
-#define EEMPTY (-302)
-
-/** Negative acknowledgment. */
-#define ENAK (-303)
-
-/** The requested operation was not performed. Try again later. */
-#define EAGAIN  (-11002)
+extern errno_t *__errno(void) __attribute__((const));
 
 #endif
Index: uspace/lib/c/include/fibril_synch.h
===================================================================
--- uspace/lib/c/include/fibril_synch.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/fibril_synch.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -173,6 +173,4 @@
 extern fibril_timer_state_t fibril_timer_clear(fibril_timer_t *);
 extern fibril_timer_state_t fibril_timer_clear_locked(fibril_timer_t *);
-extern void fibril_usleep(useconds_t);
-extern void fibril_sleep(unsigned int);
 
 #endif
Index: uspace/lib/c/include/ieee80211/ieee80211.h
===================================================================
--- uspace/lib/c/include/ieee80211/ieee80211.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ieee80211/ieee80211.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,5 +38,4 @@
 #define LIBC_IEEE80211_H_
 
-#include <malloc.h>
 #include <adt/list.h>
 #include <nic/nic.h>
Index: uspace/lib/c/include/io/chardev.h
===================================================================
--- uspace/lib/c/include/io/chardev.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/io/chardev.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2011 Jan Vesely
+ * Copyright (c) 2017 Jiri Svoboda
  * All rights reserved.
  *
@@ -33,9 +34,15 @@
 #define LIBC_IO_CHARDEV_H_
 
-#include <types/common.h>
 #include <async.h>
+#include <stddef.h>
 
-ssize_t chardev_read(async_exch_t *, void *, size_t);
-ssize_t chardev_write(async_exch_t *, const void *, size_t);
+typedef struct {
+	async_sess_t *sess;
+} chardev_t;
+
+extern int chardev_open(async_sess_t *, chardev_t **);
+extern void chardev_close(chardev_t *);
+extern int chardev_read(chardev_t *, void *, size_t, size_t *);
+extern int chardev_write(chardev_t *, const void *, size_t, size_t *);
 
 #endif
Index: uspace/lib/c/include/io/chardev_srv.h
===================================================================
--- uspace/lib/c/include/io/chardev_srv.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/io/chardev_srv.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -59,6 +59,7 @@
 	int (*open)(chardev_srvs_t *, chardev_srv_t *);
 	int (*close)(chardev_srv_t *);
-	int (*read)(chardev_srv_t *, void *, size_t);
-	int (*write)(chardev_srv_t *, const void *, size_t);
+	int (*read)(chardev_srv_t *, void *, size_t, size_t *);
+	int (*write)(chardev_srv_t *, const void *, size_t, size_t *);
+	void (*def_handler)(chardev_srv_t *, ipc_callid_t, ipc_call_t *);
 };
 
Index: uspace/lib/c/include/io/con_srv.h
===================================================================
--- uspace/lib/c/include/io/con_srv.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/io/con_srv.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -69,6 +69,6 @@
 	int (*open)(con_srvs_t *, con_srv_t *);
 	int (*close)(con_srv_t *);
-	int (*read)(con_srv_t *, void *, size_t);
-	int (*write)(con_srv_t *, void *, size_t);
+	int (*read)(con_srv_t *, void *, size_t, size_t *);
+	int (*write)(con_srv_t *, void *, size_t, size_t *);
 	void (*sync)(con_srv_t *);
 	void (*clear)(con_srv_t *);
Index: uspace/lib/c/include/io/klog.h
===================================================================
--- uspace/lib/c/include/io/klog.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/io/klog.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,15 +44,10 @@
 #include <abi/log.h>
 
-extern size_t klog_write(log_level_t, const void *, size_t);
-extern int klog_read(void *, size_t);
+extern int klog_write(log_level_t, const void *, size_t);
+extern int klog_read(void *, size_t, size_t *);
 
 #define KLOG_PRINTF(lvl, fmt, ...) ({ \
-	char *_fmt = str_dup(fmt); \
-	size_t _fmtsize = str_size(_fmt); \
-	if (_fmtsize > 0 && _fmt[_fmtsize - 1] == '\n') \
-		_fmt[_fmtsize - 1] = 0; \
 	char *_s; \
-	int _c = asprintf(&_s, _fmt, ##__VA_ARGS__); \
-	free(_fmt); \
+	int _c = asprintf(&_s, fmt, ##__VA_ARGS__); \
 	if (_c >= 0) { \
 		_c = klog_write((lvl), _s, str_size(_s)); \
Index: uspace/lib/c/include/io/serial.h
===================================================================
--- uspace/lib/c/include/io/serial.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/lib/c/include/io/serial.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_IO_SERIAL_H_
+#define LIBC_IO_SERIAL_H_
+
+#include <async.h>
+#include <ipc/serial_ctl.h>
+
+typedef struct {
+	async_sess_t *sess;
+} serial_t;
+
+extern int serial_open(async_sess_t *, serial_t **);
+extern void serial_close(serial_t *);
+extern int serial_set_comm_props(serial_t *, unsigned, serial_parity_t,
+    unsigned, unsigned);
+extern int serial_get_comm_props(serial_t *, unsigned *, serial_parity_t *,
+    unsigned *, unsigned *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/ipc/chardev.h
===================================================================
--- uspace/lib/c/include/ipc/chardev.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/chardev.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,6 +41,10 @@
 typedef enum {
 	CHARDEV_READ = IPC_FIRST_USER_METHOD,
-	CHARDEV_WRITE
+	CHARDEV_WRITE,
 } chardev_request_t;
+
+enum {
+	CHARDEV_LIMIT = CHARDEV_WRITE + 1
+};
 
 #endif
Index: uspace/lib/c/include/ipc/common.h
===================================================================
--- uspace/lib/c/include/ipc/common.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/common.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,6 +40,9 @@
 #include <abi/proc/task.h>
 #include <futex.h>
+#include <abi/cap.h>
 
 #define IPC_FLAG_BLOCKING  0x01
+
+struct async_call;
 
 typedef struct {
@@ -47,7 +50,10 @@
 	task_id_t in_task_id;
 	sysarg_t in_phone_hash;
+	unsigned flags;
+	struct async_call *label;
+	cap_handle_t cap_handle;
 } ipc_call_t;
 
-typedef sysarg_t ipc_callid_t;
+typedef cap_handle_t ipc_callid_t;
 
 extern futex_t async_futex;
Index: uspace/lib/c/include/ipc/dev_iface.h
===================================================================
--- uspace/lib/c/include/ipc/dev_iface.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/dev_iface.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,5 +30,5 @@
 #define LIBC_IPC_DEV_IFACE_H_
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <types/common.h>
 
Index: uspace/lib/c/include/ipc/devman.h
===================================================================
--- uspace/lib/c/include/ipc/devman.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/devman.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,6 +36,6 @@
 #include <ipc/common.h>
 #include <adt/list.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 
 #define DEVMAN_NAME_MAXLEN  256
